#include <stdio.h>
#include <string.h>

#define BUFSIZE 1024

#define SCREEN_X     6
#define SCREEN_Y     8
#define SCREEN_INFO 10
#define BACKGR      11
#define START_GCMAP 13 /* start of global colormap */

unsigned char buf[BUFSIZE];


int get_gifsize( char *filename, int *width, int *height )
{
    FILE *fgif = fopen( filename, "r" );
    int rc = 0;

    if ( fgif ) {

            memset( blk, 0, BUFSIZE );
            fread( buf, BUFSIZE, 1, fgif );


            if ( !strncmp( "GIF", buf, 3 ) ) {

                int i;

                int screen_width  = buf[SCREEN_X]  + 256*buf[SCREEN_X+1];
                int screen_height = buf[SCREEN_Y] + 256*buf[SCREEN_Y+1];
                int use_global_colormap = ( buf[SCREEN_INFO] & 0x80 ) >> 7;
                int pixeldepth          = ( buf[SCREEN_INFO] & 0x07 ) + 1;
                int backgr              = buf[BACKGR];
                int startimg            = START_GCMAP +
                    use_global_colormap * 3 * ( 1 << pixeldepth );

#if 0
                for ( i=0; i<BUFSIZE; i++ ) {

                    printf( "%-2d: $%02x %-3d", i, buf[i], buf[i] );
                    if ( buf[i] >= 32 )
                        printf( " '%c'\n", buf[i] );
                    else
                        printf( "\n" );

                }
#endif
                printf( "screen : %dx%d\n", screen_width, screen_height );
                printf( "colmap : %s\n",
                        ( use_global_colormap ? "global" : "no global" ) );
                printf( "pxldept: %d\n", pixeldepth );
                printf( "backgr : %d\n", backgr );

                printf( "imgsep : \"%c\" @ $%x\n", buf[startimg], startimg );

                *width  = buf[startimg+5] + 256*buf[startimg+6];
                *height = buf[startimg+7] + 256*buf[startimg+8];

                printf( "\nsize   : %dx%d\n", *width, *height );

                rc = 1;

            } else
                fprintf( stderr, "Not a gif file\n" );


        fclose( fgif );

    } else
        perror( "can't open file");

    return( rc );
}


int main( int argc, char *argv[] )
{
    int rc = 1; /* return code */

    if ( argc == 2 ) {

        int w;
        int h;

        rc = !get_gifsize( argv[1], &w, &h );

    } else
        fprintf( stderr, "Usage: gifsize filename\n" );

    return( rc );
}
