#include <stdio.h>
#include <string.h>

#include "ugly/types.h"

#define BUFSIZE 4096

/* markers for image info */
UBYTE msof[] = {
    /* M_SOF0  */ 0xc0,
    /* M_SOF1  */ 0xc1,
    /* M_SOF2  */ 0xc2,
    /* M_SOF3  */ 0xc3,
    /* M_SOF5  */ 0xc5,
    /* M_SOF6  */ 0xc6,
    /* M_SOF7  */ 0xc7,
    /* M_SOF9  */ 0xc9,
    /* M_SOF10 */ 0xca,
    /* M_SOF11 */ 0xcb,
    /* M_SOF13 */ 0xcd,
    /* M_SOF14 */ 0xce,
    /* M_SOF15 */ 0xcf,
    /* end     */ 0x00 };

unsigned char buf[BUFSIZE];


int get_jfifsize( char *filename, int *width, int *height )
{
    FILE *fjfif = fopen( filename, "r" );
    int rc = 0;

    if ( fjfif ) {

            memset( buf, 0, BUFSIZE );
            fread( buf, BUFSIZE, 1, fjfif );


            if ( buf[0] == 0xff ) {

                BOOL found = FALSE;
                size_t   i = 0;

                while ( !found && ( i< BUFSIZE ) ) {

                    if ( buf[i] == 0xff ) {

                        BOOL is_msof = FALSE;
                        int  j = 0;

                        printf( "%04x: %02x %02x: (%02x%02x %02x%02x) ",
                                 i, buf[i], buf[i+1],
                                 buf[i+2], buf[i+3], buf[i+4], buf[i+5] );

                        /* check if marker is of required type */
                        while ( !is_msof && msof[j] )
                            if ( buf[i+1] == msof[j] )
                                is_msof = TRUE;
                            else
                                j++;

                        if ( is_msof ) {


#if 1
                            for ( j=0; j<24; j++ ) {

                                printf( "\n  %-2d: $%02x %-3d",
                                        j, buf[i+j], buf[i+j] );
                                if ( buf[i+j] >= 32 )
                                    printf( " '%c'", buf[i+j] );

                            }
#endif
                            *width  = buf[i+8] + 256*buf[i+7];
                            *height = buf[i+6] + 256*buf[i+5];
                            printf( "\nsize   : %dx%d\n", *width, *height );
                            found = TRUE;

                        } else
                            printf( "ignore\n" );
                    }

                    i++;

                }



                rc = 1;

            } else
                fprintf( stderr, "Not a jfif file\n" );


        fclose( fjfif );

    } else
        perror( "can't open file");

    return( rc );
}


int main( int argc, char *argv[] )
{
    int rc = 1; /* return code */

    if ( argc == 2 ) {

        int w;
        int h;

        rc = !get_jfifsize( argv[1], &w, &h );

    } else
        fprintf( stderr, "Usage: jfifsize filename\n" );

    return( rc );
}
