#include <stdio.h>
#include <string.h>
#include <time.h>

#define BUFSIZE 99
#define DEFAULT_FORMAT "%A %d-%b-%Y %H:%M:%S"

int main( int argc, char *argv[] )
{
    char   buf[BUFSIZE];
    char  *format = DEFAULT_FORMAT;
    time_t now    = time( NULL );
    int    result = 20;

    if ( (argc > 2) || ((argc==2) && !strcmp( argv[1], "-h" )) )
    {
        fputs( "now - display current time\n"
               "(C) by Tommy-Saftwrx in 1996; Freeware\n"
               "usage: now [format_description;default=`"
               DEFAULT_FORMAT
               "']\n"
               , stderr );
        result = 5;
    }
    else
    {
        if ( argc==2)
            format = argv[1];

        if ( strftime( buf, BUFSIZE, format, localtime( &now ) ) )
        {
            fputs( buf, stdout );
            result = 0;
        }
        else
        {
            fputs( "now: buffer too small\n", stderr );
        }
    }

    return( result );
}
